from z3 import *
from random import randint
import time
import random
import string
import statistics

def randomString(stringLength=8):
    letters = string.ascii_lowercase
    return ''.join(random.choice(letters) for i in range(stringLength))

communicationCost = Real('communicationCost')
communicationCostDown = Real('communicationCostDown')
computationCost = Real('computationCost')
#communicationCostUser = Real('communicationCostUser')
#communicationDownUser = Real('communicationDownUser')
#computationCostUser = Real('computationCostUser')
communicationTime = Real('communicationTime')
computationTime = Real('computationTime')
#usuarios = Int('usuarios')

#Objectives = {'energy','latency'}
#Objectives = {'energy'}


#todas tareas 19
nUsers = 1
nConstraints = 2
nMeshlium = 0
nNodes = 25
nFeatures = 15
nFeaturesLocated = 15
nTask = nFeatures + nFeaturesLocated
nNodes = nNodes + nFeaturesLocated
#{task, node}
times = [[]]
for row in range(1):
	nTask = 8*10 + 10

	times = [ [0 for c in range(5) ] 
		      for r in range(8) ]
		
	for experiment in range(5):

		nFeaturesLocated = round(nTask*random.uniform(0.20,0.30))
		nFeatures = nTask - nFeaturesLocated
		nConstraints = round(random.uniform(0.1,0.3)*nFeatures)
		nNodes = 30

		objectives = random.uniform(0,100)
		Objectives = {''}
		if objectives < 33:
			Objectives.add('energy')
		elif objectives > 33 and objectives < 66:
			Objectives.add('latency')
		elif  objectives > 66:
			Objectives.add('energy')
			Objectives.add('latency')

		assignment = [ [ Bool("ASING_%s_%s" % (r,c)) for c in range(nNodes+nUsers-1) ] 
		      for r in range(nTask*nUsers) ]

		#{node, user}
		#RAMresources = [ [ Real("RAM_%s_%s" % (r,c)) for c in range(nUsers+nUsers-1) ] 
		#for r in range(nNodes) ]


		#data to be transmitted between tasks
		relation = [ [ 0 for c in range(nTask) ] 
		      for r in range(nTask) ]

		for n in range(nFeatures - 1):
			relation[nFeaturesLocated + n][nFeaturesLocated+ n+1] = random.uniform(30/8,30000/8)
		#relation[nFeaturesLocated + 2][nFeaturesLocated+ 3] = random.uniform(30/8,30000/8)
		#relation[nFeaturesLocated + 3][nFeaturesLocated+ 4] = random.uniform(30/8,30000/8)
		#relation[nFeaturesLocated + 4][nFeaturesLocated+ 5] = random.uniform(30/8,30000/8)
		#
		#	relation[nFeaturesLocated + 5][nFeaturesLocated+ 6] = random.uniform(30/8,30000/8)
		#	relation[nFeaturesLocated + 7][nFeaturesLocated+ 8] = random.uniform(30/8,30000/8)
		#	relation[nFeaturesLocated + 6][nFeaturesLocated+ 9] = random.uniform(30/8,30000/8)
		#	relation[nFeaturesLocated + 8][nFeaturesLocated+ 9] = random.uniform(30/8,30000/8)

		tasks = [ [ 0 for c in range(9) ] 
		      for r in range(nTask) ]

		nodes = [ [ 0 for c in range(14) ] 
		      for r in range(nNodes) ]


		def randomString(stringLength=2):
		    letters = string.ascii_lowercase
		    return ''.join(random.choice(letters) for i in range(stringLength))

		
		
		for x in range(0, nFeaturesLocated):
			location = randomString()
			tasks[x][0] = 10 #CameraCalibration
			tasks[x][1] = 10
			tasks[x][2] = x
			tasks[x][3] = 0
			tasks[x][4] = {''}
			tasks[x][5] = {''}
			tasks[x][6] = {}
			tasks[x][7] = location
			tasks[x][8] = 'mote'

			nodes[x][0] = 10
			nodes[x][1] = 10
			nodes[x][2] = 0.1
			nodes[x][3] = 0.00023
			nodes[x][4] = 6000
			nodes[x][6] = 0.1
			nodes[x][7] = 250000000
			nodes[x][8] = {''}
			nodes[x][9] = {''}
			nodes[x][10] = 'mote'
			nodes[x][11] = location
			nodes[x][12] = 'public'
			nodes[x][13] = {'wlan'}


		for x in range(nFeaturesLocated, nTask):
			tasks[x][0] = random.uniform(120,2400)
			tasks[x][1] = random.uniform(10,100)
			tasks[x][2] = x
			tasks[x][3] = 0
			tasks[x][4] = {''}
			tasks[x][5] = {''}
			tasks[x][6] = {}
			tasks[x][7] = 'none'
			tasks[x][8] = 'computing'



		#{0-CPU, 1-RAM, 2-user, 3-minimal transmission, 4-sensingRequirements, 5-peripheral requirements, 6-transmit, 7-exactLocation, 8 type}



		#{0-CPU, 1-Bandwidth. 2-Power Upload, 3-k, 4-RAM, 5-Policy, 6-Power Download, 7-BandwidthDown, 8 -Sensing units, 9- Peripherals, 10-Type, 11- Location, 12-Owner,13 - Communication}




		for x in range(nFeaturesLocated, nNodes):
			nodes[x][0] = random.uniform(1000000000,2400000000)
			nodes[x][1] = random.uniform(150000000,200000000)
			nodes[x][2] = random.uniform(0.3,0.4)
			nodes[x][3] = random.uniform(0.00000003,0.0000005)
			nodes[x][4] = random.uniform(2000,6000)
			nodes[x][6] = random.uniform(0.2,0.4)
			nodes[x][7] = random.uniform(150000000,200000000)
			nodes[x][8] = {''}
			nodes[x][9] = {''}
			nodes[x][10] = 'computing'
			nodes[x][11] = 'anyplace'
			nodes[x][12] = 'public'
			nodes[x][13] = {'wlan'}


		#for aux in range(nNodes):
		#	print('posision nodes ' + str(nodes[aux][11]))

		#Edges of the task-call graph
		constraints = [ [ 0 for c in range(nTask) ] 
		      for r in range(nConstraints) ]

		#[0] max time to be executed
		#[1] number of tasks involved in the restriction
		#[2...n] index of the involved tasks
		#create random time restrictions 
		for n in range(nConstraints):
			aux = round(random.uniform(0.2,0.5)*nFeatures)
			constraints[n][0] = random.uniform(0.8,5)
			constraints[n][1] = aux
			featureIni = random.uniform(0,nFeatures-aux)
			for x in range(aux):
				constraints[n][aux+2] = x + featureIni + nFeaturesLocated
				


		#{0-CPU, 1-Bandwidth. 2-Power Upload, 3-k, 4-RAM, 5-Policy, 6-Power Download, 7-BandwidthDown, 8 -Sensing units, 9- Peripherals, 10-Type, 11- Location, 12-Owner,13 - Communication}
		#CMC.append({'1080p': 3600*1024, '720p': 1800*1024, '480p': 1000*1024, '360p': 700*1024})




		#{0-CPU, 1-Bandwidth. 2-Power Upload, 3-k, 4-RAM, 5-Policy, 6-Power Download, 7-BandwidthDown, 8 -Peripheralps, 9- Sensing, 10-Type, 11- Location, 12-Owner,13 - Communication}
		#{0-CPU, 1-RAM, 2-user, 3-minimal transmission, 4-sensingRequirements, 5-peripheral requirements, 6-transmit, 7-exactLocation, 8 type}


		#def meets (node,task):
		#	result = False
		#		if task[4] <= nodes[node][8] and  task[5] <= nodes[node][9] and task[6] <= nodes[node][1] and (task[7] == 'none' or task[7] == nodes[node][11]) and task[8] == nodes[node][11]:
		#			result = True
		#	return result

		def getDistance(lat1,lon1,lat2,lon2,connectivity, range):
				R = 6373.0
				dlon = lon2 - lon1
				dlat = lat2 - lat1

				a = sin(dlat / 2)**2 + cos(lat1) * cos(lat2) * sin(dlon / 2)**2
				c = 2 * atan2(sqrt(a), sqrt(1 - a))

				distance = R * c
				available = distance < range

				return available


		def numberUsers(RAMSolution):
			minimum = 99999999
			for n in range(1, nNodes):
				if nodes[n][10] == 'computing' and RAMSolution[n] > 0:
					ram = RAMSolution[n]
					if len(nodes[n][11]) <= 3:
						for t in range(nTask):
							if tasks[t][7] == nodes[n][11]:
								ram = ram - tasks[t][1]
					if ram > 0:
							relation = round(nodes[n][4]/ram)
							if relation < minimum:
								minimum = relation
			return minimum


		#configuring the policy (user node)
		for x in range(nUsers):
			nodes[x][5] = 1

		#configuring the policy (rest of nodes). All nodes has been configured with the same node weighting (1)
		for x in range(nUsers, nNodes):
			nodes[x][5] = 1


		timeBefore = time.time()

		opt = Optimize()

		opt.add([Sum([If(assignment [t][m] ,1,0) for m in range(nNodes)]) == 1 for t in range(nTask*nUsers)])
		for t in range(nTask):
			#opt.add(Sum([If(assignment [t][node] ,  (tasks[t][3] <= nodes[node][1]) * (tasks[t][8] == nodes[node][10]) * ((tasks[t][7] == 'none') + (tasks[t][7] == nodes[node][11])),1) for node in range(nNodes)]) == nNodes)
			opt.add(Sum([If(assignment [t][node] ,  ((tasks[t][7] == 'none') + (tasks[t][7] == nodes[node][11])),1) for node in range(nNodes)]) == nNodes)

		#opt.add([Sum([If(RAMresources [m][u] >= 0,1,0) for u in range(nUsers)]) == nUsers for m in range(nNodes)])
		#opt.add([Sum([RAMresources [m][u] for u in range(nUsers)]) <= nodes[m][4] for m in range(nNodes)])

		#RAM assignment for each node and user
		for u in range(0, nUsers):
			opt.add([Sum([assignment[t+nTask*u][m]*tasks[t+nTask*u][1] for t in range(nTask)]) <= nodes[m][4] for m in range(nNodes)])

		#time restrictions
		for c in range(0, nConstraints):
			opt.add([(Sum([simplify(assignment[constraints[c][i]+(u*nTask)][m]*If(assignment[constraints[c][j]+(u*nTask)][m],0,1)*relation[constraints[c][i]][constraints[c][j]]*1000000/nodes[m][1])for j in range(2, 2 + constraints[c][1])]) + (assignment[constraints[c][i]+(u*nTask)][m]*tasks[constraints[c][i]+(u*nTask)][0]/nodes[m][0]))*1000000 <= constraints[c][0]*1000000 for i in range(2, 2 + constraints[c][1])  for m in range(nNodes) for u in range(nUsers)])

		if 'energy' in Objectives:
			opt.add(communicationCost == Sum([Sum([Sum([Sum([simplify(assignment[i + u*nTask][m]*If(assignment[j+ u*nTask][m],0,1)*(nodes[m][2]*(relation[i][j]/nodes[m][1])*nodes[m][5])) for j in range(nTask)]) for i in range(nTask)]) for u in range(nUsers)]) for m in range(nNodes)]))
			opt.add(computationCost == Sum([Sum([simplify(assignment[i][m] * nodes[m][3] * tasks[i][0] * (nodes[m][0]**2) *nodes[m][5]) for i in range(nTask*nUsers)]) for m in range(nNodes)]))
			#opt.add(communicationCostDown == Sum([Sum([Sum([Sum([simplify(assignment[i + u*nTask][m]*If(assignment[j+ u*nTask][m],0,1)*(nodes[m][6]*(relation[j][i]/nodes[m][7])*nodes[m][5])) for j in range(nTask)]) for i in range(nTask)]) for u in range(nUsers)]) for m in range(nNodes)]) )
			#opt.minimize(communicationCost + communicationCostDown + computationCost)
			opt.minimize(communicationCost + computationCost)
		
		if 'latency' in Objectives:
			opt.add(computationTime == Sum([Sum([If(assignment[t][m], tasks[t][0]/nodes[m][0],0) for t in range(nTask)]) for m in range (nNodes)]))
			opt.add(communicationTime == Sum([Sum([Sum([Sum([simplify(If(assignment[i + u*nTask][m] * If(assignment[j+ u*nTask][m],0,1) == 1,relation[i][j]/nodes[m][1],0)) for j in range(nTask)]) for i in range(nTask)]) for u in range(nUsers)]) for m in range(nNodes)]) )
			opt.minimize(computationTime + communicationTime)

		#opt.add(usuarios == min([If(nodes[m][10] == 'computing',nodes[m][4]/(RAMresources[m][0]),99999) for m in range(nNodes)]))
		#opt.maximize(usuarios)

		#COSTES PARA EL USUARIO
		#opt.add(communicationCostUser == Sum([Sum([Sum([simplify(assignment[i + u*nTask][0]*If(assignment[j+ u*nTask][0],0,1)*(nodes[0][2]*nodes[0][5]*(relation[i][j]/nodes[0][1]))) for j in range(nTask)]) for i in range(nTask)]) for u in range(0,nUsers)]))
		#opt.add(communicationDownUser == Sum([Sum([Sum([simplify(assignment[i + u*nTask][0]*If(assignment[j+ u*nTask][0],0,1)*(nodes[0][6]*nodes[0][5]*(relation[j][i]/nodes[0][7]))) for j in range(nTask)]) for i in range(nTask)]) for u in range(0,nUsers)]))
		#opt.add(computationCostUser == Sum(Sum([simplify(assignment[i][0] * nodes[0][3] * tasks[i][0] * (nodes[0][0]**2) *nodes[0][5]) for i in range(nTask*nUsers)])))


		
		
		#solution = 1
		#print('Minimizing ' + str(Objectives))
		#print('*********SOLUTION************')
		#solution = solution +1
		sat = opt.check()
		m = opt.model()
		timeAfter = time.time()
		#print(str(sat))
		print(str(sat) + ' tareas: ' + str(nTask) + ' :' + str(timeAfter-timeBefore))
		#if str(sat)	=='sat':
			#times[row][experiment] = (timeAfter-timeBefore)
			#print('aqui entra')
			#print(str(times[row][experiment]))
			#print('row ' + str(row) + 'experiment ' + str(experiment))
			#print(str(timeAfter-timeBefore))
		#for t in range (nTask):
		#	for n in range (nNodes):
		#		if str(m[assignment[t][n]]) == 'True':
		#			print('Task ' + str(t) + ' assigned to device ' + str(nodes[n][11]))
		#ramNodes = []		
		#for n in range (nNodes):
		#	ram = round(m[RAMresources[n][0]].numerator_as_long()/m[RAMresources[n][0]].denominator_as_long())
		#	ramNodes.append(ram)
		#	if ram > 1:
		#		print('RAM allocated in node ' + str(nodes[n][11]) + ': ' + str(ram))
		#	else:
		#		print('RAM allocated in node ' + str(nodes[n][11]) + ': ' + str(0))
		#print('Users supported: ' + str(numberUsers(ramNodes)))
		#print('**************************')
	#
		#print()
		##print (sorted ([(d, m[d]) for d in m], key = lambda x: str(x[0])))
		#print('\n')
		#print('Battery level (user node): ' + str(batteryLevel) + '%')
		#print('Energy consumption in the DI: ' + str(m[computationCost].numerator_as_long()/m[computationCost].denominator_as_long() + m[communicationCost].numerator_as_long()/m[communicationCost].denominator_as_long() + m[communicationCostDown].numerator_as_long()/m[communicationCostDown].denominator_as_long() - m[computationCostUser].numerator_as_long()/m[computationCostUser].denominator_as_long() - m[communicationCostUser].numerator_as_long()/m[communicationCostUser].denominator_as_long()) + ' (J)')
		#print('Energy consumption in the user node: ' + str(m[computationCostUser].numerator_as_long()/m[computationCostUser].denominator_as_long() + m[communicationCostUser].numerator_as_long()/m[communicationCostUser].denominator_as_long() +  m[communicationDownUser].numerator_as_long()/m[communicationDownUser].denominator_as_long()) + ' (J)')
		#totalTime = timeAfter - timeBefore
		#print('Execution time: ' + str(totalTime) + ' (s)')


#for r in range(7):
#	print(str(times[r]))
#	print(str(r*10 + 10) + ' TASKS ******')
#	print('Tiempo media '  + str(statistics.mean(times[r])))
#	print('Tiempo desviacion' + str(statistics.stdev(times[r])))